# Source for file Db2.php

Documentation is available at Db2.php

1. <?php
2. /*
3. * $Id: Db2.php 1181 2007-03-20 23:22:51Z gnat $
4. *
5. * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6. * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7. * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8. * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9. * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10. * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11. * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12. * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13. * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14. * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15. * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16. *
17. * This software consists of voluntary contributions made by many individuals
18. * and is licensed under the LGPL. For more information, see
19. * <http://www.phpdoctrine.com>.
20. */
21. Doctrine::autoload('Doctrine_Connection');
22. /**
23. * Doctrine_Connection_Db2
24. *
25. * @package Doctrine
26. * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
27. * @category Object Relational Mapping
28. * @link www.phpdoctrine.com
29. * @since 1.0
30. * @version $Revision: 1181 $
31. * @author Konsta Vesterinen <kvesteri@cc.hut.fi>
32. */
33. class Doctrine_Connection_Db2 extends Doctrine_Connection
34. {
35. /**
36. * Adds an driver-specific LIMIT clause to the query
37. *
38. * @param string $query query to modify
39. * @param integer $limit limit the number of rows
40. * @param integer $offset start reading from given offset
41. * @return string the modified query
42. */
43. public function modifyLimitQuery($query, $limit, $offset)
44. {
45. if ($limit <= 0)
46. return $query;
48. if ($offset == 0) {
49. return $query . ' FETCH FIRST '. $limit .' ROWS ONLY';
50. } else {
51. $sqlPieces = explode('from', $query);
52. $select = $sqlPieces[0];
53. $table = $sqlPieces[1];
55. $col = explode('select', $select);
57. $sql = 'WITH OFFSET AS(' . $select . ', ROW_NUMBER() ' .
58. 'OVER(ORDER BY ' . $col[1] . ') AS dctrn_rownum FROM ' . $table . ')' .
59. $select . 'FROM OFFSET WHERE dctrn_rownum BETWEEN ' . $offset .
60. 'AND ' . ($offset + $limit - 1);
61. return $sql;
62. }
63. }
64. }